<template>
  <form class="form">
    <h1 class="form__header">Overview</h1>
    <div class="form-overview">
      <div class="form-overview__field">
        <p class="form-overview__title">First name</p>
        <p class="form-overview__data">{{ allInfo.firstName }}</p>
      </div>
      <div class="form-overview__field">
        <p class="form-overview__title">Last name</p>
        <p class="form-overview__data"> {{ allInfo.lastName }} </p>
      </div>
      <div class="form-overview__field">
        <p class="form-overview__title">E-mail</p>
        <p class="form-overview__data">{{ allInfo.email }}</p>
      </div>
      <div class="form-overview__field" v-for="phone in allInfo.phones" :key="phone.id">
        <p class="form-overview__title">Phone</p>
        <p class="form-overview__data">{{ phone.number }}</p>
      </div>
      <div class="form-overview__field">
        <p class="form-overview__title">Membership</p>
        <p class="form-overview__data">{{ allInfo.membership }}</p>
      </div>
    </div>
    <button
        type="button"
        class="button _add"
        @click="edit"
    >Edit information
    </button>
    <button
        type="submit"
        @click.prevent="submit"
        class="button _nav">Submit
    </button>
    <button
        type="submit"
        @click.prevent="back"
        class="button _nav _white">Back
    </button>
  </form>
  <template v-if="renderModal">
    <EditModal v-if="showEditModal" @close="close"/>
  </template>
</template>

<script lang="ts">
import {computed, defineComponent, ref} from 'vue';
import {useStore} from 'vuex'
import {useRouter} from "vue-router";
import EditModal from "@/components/modals/EditModal.vue";
import api from "@/api/index";
import {UserFormDetails, SelectedPhoneInfo, Steps} from "@/models/types";

export default defineComponent({
  components: {
    EditModal,
  },
  setup() {
    const {push} = useRouter()
    const store = useStore()
    const renderModal = ref(false)
    const showEditModal = ref(false)
    const allInfo = computed(() => store.getters.allInfo)

    async function submit() {
      const data = Object.keys(allInfo.value).reduce((result: UserFormDetails, key: string) => {
        if (key === 'phones') {
          result.phones = allInfo.value.phones.reduce((acc: Record<string, string>, curr: SelectedPhoneInfo) => {
            acc[curr.selectedType.name] = curr.number
            return acc
          }, {} as UserFormDetails)
        } else if (key === 'firstName' || key === 'lastName' || key === 'email' || key === 'membership') {
          result[key] = allInfo.value[key] as string
        }
        return result
      }, {} as UserFormDetails)

      try {
        await api.store(data);
        store.dispatch('reset');
        push({name: 'contact-info'});

      } catch (error) {
        alert(error?.message)
      }

    }

    function edit() {
      renderModal.value = true
      showEditModal.value = true
      const body = document.querySelector('body')
      if (body) body.style.overflow = 'hidden'
    }

    function close() {
      const body = document.querySelector('body')
      if (body) body.style.overflow = 'auto'
      showEditModal.value = false
    }

    function back() {
      push({name: 'membership'})
      store.dispatch('stepBack', Steps[Steps.Membership])
    }

    return {allInfo, back, submit, renderModal, showEditModal, edit, close}
  }
});
</script>
